<?php
$mobj->decor_folder	= 'sbs_wp/';
$mobj->decor_file	= 'decor_help.php';
?>

<h2>Authentication and authorization</h2>

<h3>System of personal settings of user</h3>
SBS WP allow to store personal settings for one registered user by default.
This user usually used as administrator of system. This personal settings stored
as variable "$mobj->admin_profile" and can be setted in Control Script.
By default is kept next parameters:
<ul>
<li>ID</li>
<li>Login</li>
<li>Password</li>
<li>User group</li>
<li>Interface language</li>
</ul>
Variable "<b>$pers_set</b>" is used for storing a parameters at run-time.
Main goal of authentication is set variable "<b>$pers_set</b>", wich stored in
sessions.
<p />
Full advanced control of multiple users is realized by means of module U5 "Users".

<h3>How to create a process of authentication</h3>
You can use scripts of Control Panel of SBS WP as sample for building of
processes of authentication and logout.

<h3>Using a mechanism of protection of pages</h3>
You can write your own mechanism of protection but can also use next way:
<ul>
<li>
There is parameter "ug" (User Group) in profiles of users.
This is digit from 0 to 9 or char from a to z
</li>
<li>
	Lines like next can be placed in Project script to be protected:
	<pre>
$perm_dnd = $mobj->check_authority(&lt;Allowed User Groups&gt;);
if (!$perm_dnd) {$mobj->perm_dnd = TRUE; return;}
	</pre>
	This will protect pages if user group not in "Allowed User Groups"
</li>
<li>
Main control script ("<?= _MOBJ_I_ ?>") processes variable $mobj->perm_dnd
and writes a normal page or page for error "403 Forbidden"
</li>
</ul>

<h3>System of protection of objects</h3>
In SBS WP is realized common for whole system principle of protection of objects.
Any object (e.g., record in database, Project script, block of PHP or HTML-code)
can have next attributes:
<ul>
<li><b>Owner</b> - login of owner of object (in database "uid")</li>
<li><b>List of allowed groups for viewing</b> (in database "gid_r")</li>
<li><b>List of allowed groups for modification</b> (in database "gid_w")</li>
<li><b>List of allowed groups for inserting</b> (in database "gid_i")</li>
</ul>
List of allowed groups can be:
<ul>
<li>Digit - specified group allowed</li>
<li>List of digits like "24761" - enumerated groups is allowed</li>
<li>* - all groups allowed</li>
<li>"" (empty) - no groups allowed excluding owner</li>
<li>List with "-" like "483-9" - access for owner is denied</li>
</ul>
If empty groups and empty owner - nobody allowed excepting administrator

<h4>Changing attributes</h4>
Changing attributes is possible with "<?= _MOBJ_MODULES_FOLDER_ ?>u0/cp/attributes.php".
This script required modules U5 V1.6 and U15 V1.9.

<h4>Notes</h4>
<ul>
<li>At start of browsing, an user authenticated as "guest"
(thereby unauthorized user be can not).</li>
<li>Owner has full rights always, regardless of instructions of groups
(exception - "-" in list of groups).</li>
<li>Administrator has full right on all always.</li>
<li>
By default there is only one profile, so named "built-in admin profile".
Parameters for it setted in Control script in section marked "Section available
for adjustment (#2)" in variable "$mobj->admin_profile". If module U5 "Users" is
not presented then only this profile is available.
</li>
</ul>

<h4>Sharing a groups</h4>
<ul>
<li>0 - Administrators (such user may see all pages regardless of any restrictions)</li>
<li>1 ... 9 - Reserved in SBS WP</li>
<li>a ... z - Defined by end developer</li>
</ul>