<?php
/*
Library for work with mail. V1.3.1. Copyright (C) 2003 - 2007 Richter
Additional information: http://wpdom.com
*/

class Mail_sender {
  var $from_addr;	// Sender address
  var $from_name;	// Sender name
  var $to;		// Address of a recipient or array of these addresses
  var $headers;
  var $body;		// Main message
  var $body_type;	// Main message encoding (text/plain or text/html)
  var $priority;	// Letter priority;

  function Mail_sender()
  {
    $this -> from_addr = "";
    $this -> from_name = "";
    $this -> to = "";
    $this -> body = "";
    $this -> body_type = 'text/plain';
    $this -> headers = Array();
    $this -> subj = "";
    $this -> priority = 3;
  }

  // Attachs some content
  function attach_content($file_name = '', $file_content, $encoding_type = 'application/octet-stream', $in_letter_id = FALSE)
  {
    $this -> headers[] = array(
    "name" => $file_name,
    "content" => $file_content,
    "encode" => $encoding_type,
    "cid" => $in_letter_id
    );
  }

  // Builds a part of letter
  function build_part($header)
  {
    $cnt = $header["content"];
    if ($header["encode"] == "text/html") {
      $cnt = convert_cyr_string($cnt,"w","k");
//      $cnt = chunk_split($cnt);
      $encoding = '8bit';
      $charset = '; charset="koi8-r"';
    } elseif ($header["encode"] == "text/plain") {
      $cnt = convert_cyr_string($cnt,"w","k");
//      $cnt = chunk_split(base64_encode($cnt));
//      $encoding = "base64";
      $encoding = '8bit';
      $charset = '; charset="koi8-r"';
    } else {
      $cnt = chunk_split(base64_encode($cnt));
      $encoding = "base64";
    }
    return "Content-Type: ".$header["encode"].
    ($header["name"]? "; name = \"".$header["name"]."\"" : "")."$charset\nContent-Transfer-Encoding: $encoding".($header['cid']?"\nContent-ID: <".$header['cid'].">":"")."\n\n$cnt\n";
  }

  // Attachs a file (Use it for make attachment)
  // $in_letter_id: ID in body of letter or FALSE
  function attach_file($filename, $filename_in_letter, $enc_type, $in_letter_id = FALSE)
  {
    if ($filename_in_letter == '') $filename_in_letter = $filename;
    $fp = fopen($filename,"r");
    $data = fread($fp, filesize($filename));
    fclose($fp);
    $this->attach_content($filename_in_letter, $data, $enc_type, $in_letter_id);
  }

  // Prepare letter
  function prepare_letter()
  {
    $mime = '';
    if (!empty($this->from_addr)) {
      if ($this->from_name != '') $from = $this->from_name.' <'.$this->from_addr.'>';
      else $from = $this->from_addr;
      $from = "From: $from\nReply-To: $from\n";
      $mime .= convert_cyr_string($from,"w","k");
    }
    $mime .= "X-Priority: ".$this->priority."\nMIME-Version: 1.0\n";
    if (count($this->headers) > 0) {	// Multipart letter
      // Main body as part of letter
      $this->attach_content('', $this->body, $this->body_type);
      // Compiling a parts
      $boundary = 'b'.md5(uniqid(time())); // Boundary
      $multipart = "Content-Type: multipart/mixed; boundary =$boundary\n\nThis is a MIME encoded letter\n\n--$boundary";
      for ($I = sizeof($this->headers)-1; $I >= 0; $I--) {
        $multipart .= "\n".$this->build_part($this->headers[$I])."--$boundary"; // Inserting part of letter
      }
      $multipart .= "--\n";
      $mime .= $multipart;
    } elseif ($this->body != '') {	// Simply letter
      $this->body = convert_cyr_string($this->body,"w","k");
      $mime .= "Content-Type: ".$this->body_type."; charset=\"koi8-r\"\nContent-Transfer-Encoding: 8bit\n\n".$this->body;
    }

    $this->subj = convert_cyr_string($this->subj, "w", "k");
    if (!is_array($this->to)) $this->to = array($this->to);
    $this->mime = $mime;
  }

  // Sends letter
  function send_letter()
  {
    foreach ($this->to as $to) {
      $to = convert_cyr_string($to,"w","k");
      @mail($to, $this->subj, "", $this->mime);
    }
  }
}
?>